local reversedHeistsInitDone = false
local secureZoneSet = false

local function contains(tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end
    return false
end

local origfunc = ElementAreaTrigger.init
function ElementAreaTrigger:init(...)
	origfunc(self, ...)

if Network:is_server() then
	if not reversedHeistsInitDone then
		_ReversedHeistsData = nil

		local currentLevel = managers.job:current_level_id()
		
		if currentLevel == "branchbank" and managers.job:current_job_id() == "branchbank_deposit" then
			currentLevel = "branchbank_deposit"
		end

		local file = io.open("mods/Reversed heists/heists/" .. currentLevel .. ".json", "r")

		if file then
			local temp = file:read("*all")
			file:close()

			_ReversedHeistsData = json.decode(temp)
		end

		reversedHeistsInitDone = true
	end

	if _ReversedHeistsData and _ReversedHeistsData.reverse then
		if _ReversedHeistsData.secureIds
			and contains(_ReversedHeistsData.secureIds, self._id)
			and _ReversedHeistsData.secureZones
		then
		local curNum = 1
			if _ReversedHeistsSecZoneNum then
				_ReversedHeistsSecZoneNum2 = math.random(#_ReversedHeistsData.secureZones)
				curNum = _ReversedHeistsSecZoneNum2
			else
				_ReversedHeistsSecZoneNum = math.random(#_ReversedHeistsData.secureZones)
				curNum = _ReversedHeistsSecZoneNum
			end
			local secZone = _ReversedHeistsData.secureZones[curNum]
			secureZoneSet = true
			local posx = secZone.pos[1] or 0
			local posy = secZone.pos[2] or 0
			local posz = secZone.pos[3] or 0
			self._shapes[1]:set_position(Vector3(posx, posy, posz))
			self._shapes[1]:set_rotation(Rotation(0, 0, 0))
			self._shapes[1]._properties.width = secZone.params[1] or 1000
			self._shapes[1]._properties.depth = secZone.params[2] or 1000
			self._shapes[1]._properties.height = secZone.params[3] or 1000
			if _ReversedHeistsSecureZone then
				_ReversedHeistsSecureZone2 = self
			else
				_ReversedHeistsSecureZone = self
			end
		elseif _ReversedHeistsData.secureIdsDisable and contains(_ReversedHeistsData.secureIdsDisable, self._id) then
			self._shapes[1]:set_position(Vector3(0, 0, 99999))
		end
	end
end
end