local function disableInteraction(unitPos)
    if not _ReversedHeistsData.keepInteractPositions then
		return true
    end

    for index, value in ipairs(_ReversedHeistsData.keepInteractPositions) do
        if mvector3.distance_sq(unitPos, Vector3(value[1], value[2], value[3])) < 100000 then
            return false
        end
    end
    return true
end


local origfunc = HUDManager.blackscreen_fade_in_mid_text
function HUDManager:blackscreen_fade_in_mid_text()
	if Network:is_server() and _ReversedHeistsData and _ReversedHeistsData.reverse then
		if _ReversedHeistsData.interactFilters then
			for k,v in pairs(_ReversedHeistsData.interactFilters) do
				for _,unit in ipairs(World:find_units_quick("all", managers.slot:get_mask("world_geometry"))) do
					if unit and type(unit) ~= "number" then
						local type = tostring(unit:type():key())
						if type == v then
							if unit.interaction and unit:position() and disableInteraction(unit:position()) then
								local inter = unit:interaction()
								if inter then
									unit:interaction():set_active(false, true)
									--log("REMOVED");
								end
							end
						end
					end
				end
			end
		end

		if _ReversedHeistsData.lootOptions and _ReversedHeistsData.lootPositions then
			local unitRotation = Vector3(0, 0, 0)
			local currentUnit

			local num = 1
			while num <= 3 do
				local curPos = Vector3(_ReversedHeistsData.lootPositions[num][1], _ReversedHeistsData.lootPositions[num][2], _ReversedHeistsData.lootPositions[num][3])

				local inx = math.random(#_ReversedHeistsData.lootOptions)
				local currentUnit = World:spawn_unit(Idstring(_ReversedHeistsData.lootOptions[inx]), curPos, unitRotation)
				currentUnit:interaction():set_active(true, true)

				num = num + 1
			end
		end
	end

	return origfunc(self)
end

