local origfunc = LootManager.server_secure_loot
function LootManager:server_secure_loot(carry_id, multiplier_level, silent)
	origfunc(self, carry_id, multiplier_level, silent)

	if _ReversedHeistsData and _ReversedHeistsData.lootOptions and _ReversedHeistsData.lootCarryIds then
		local num = 0
		while num <= #_ReversedHeistsData.lootCarryIds do
			if _ReversedHeistsData.lootCarryIds[num] == carry_id then
				break
			end
			num = num + 1
		end
		
		if not _ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].secIndex then
			_ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].secIndex = 1
		end
		
		local index = _ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].secIndex
		_ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].secIndex = index + 1

		if num > 0 and num <= #_ReversedHeistsData.lootOptions and _ReversedHeistsData.lootOptions[num] then
			if (_ReversedHeistsData.lootSpawnSecured == nil or _ReversedHeistsData.lootSpawnSecured) 
				and _ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].securedPositions
				and _ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].securedPositions[index]
			then
				local params = _ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum].securedPositions[index]
				if params then
					local pos = Vector3(params[1], params[2], params[3])
					local currentUnit = World:spawn_unit(Idstring(_ReversedHeistsData.lootOptions[num]), pos, Vector3(0, 0, 0))
					currentUnit:interaction():set_active(false, true)
				end
			end
			
			if index >= (_ReversedHeistsData.lootMaxAmount or 999) then
				_ReversedHeistsSecureZone:set_enabled(false)
				_ReversedHeistsSecureZone._shapes[1]:set_position(Vector3(0, 0, 99999))
				if _ReversedHeistsSecureZoneWaypointId then
					managers.hud:remove_waypoint(_ReversedHeistsSecureZoneWaypointId)
				end
			end
		end
		
		_ReversedHeistsSecZoneNum = math.random(#_ReversedHeistsData.secureZones)
		local secZone = _ReversedHeistsData.secureZones[_ReversedHeistsSecZoneNum]
		local posx = secZone.pos[1] or 0
		local posy = secZone.pos[2] or 0
		local posz = secZone.pos[3] or 0
		_ReversedHeistsSecureZone._shapes[1]:set_position(Vector3(posx, posy, posz))
		_ReversedHeistsSecureZone._shapes[1]:set_rotation(Rotation(0, 0, 0))
		_ReversedHeistsSecureZone._shapes[1]._properties.width = secZone.params[1] or 1000
		_ReversedHeistsSecureZone._shapes[1]._properties.depth = secZone.params[2] or 1000
		_ReversedHeistsSecureZone._shapes[1]._properties.height = secZone.params[3] or 1000

		managers.hud._hud.waypoints[_ReversedHeistsSecureZoneWaypointId].position = Vector3(posx, posy, posz)
		
		local pos = _ReversedHeistsData.lootPositions[math.random(#_ReversedHeistsData.lootPositions)]
		local curPos = Vector3(pos[1], pos[2], pos[3])
		local inx = math.random(#_ReversedHeistsData.lootOptions)
		local currentUnit = World:spawn_unit(Idstring(_ReversedHeistsData.lootOptions[inx]), curPos, Vector3(0, 0, 0))
		currentUnit:interaction():set_active(true, true)
	end
end